Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"<<", "IGraphM`"}]], "Input"],

Cell[BoxData["\<\"Evaluate IGDocumentation[] to get started.\"\>"], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"toMat", "[", 
   RowBox[{"vec_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"SparseArray", "@", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"Flatten", "@", 
      RowBox[{"Riffle", "[", 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"vec", ",", "n"}], "]"}], ",", "0", ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}], ",", "2"}], "}"}]}], "]"}]}], ",", "n"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.675143799751005*^9, 3.675143849046874*^9}, {
  3.6751438794092607`*^9, 3.675143944286613*^9}, {3.675144162840683*^9, 
  3.675144164761527*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"toMatU", "[", 
   RowBox[{"vec_", ",", "n_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"#", "+", 
     RowBox[{"Transpose", "[", "#", "]"}]}], "&"}], "@", 
   RowBox[{"Prepend", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"PadRight", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Part", "[", 
          RowBox[{"vec", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"k", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"k", "-", "1"}], ")"}], "/", "2"}]}]}], ")"}], ";;", 
            
            RowBox[{"(", 
             RowBox[{"k", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"k", "+", "1"}], ")"}], "/", "2"}]}], ")"}]}]}], 
          "]"}], ",", "\[IndentingNewLine]", "n"}], "\[IndentingNewLine]", 
        "]"}], "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"k", ",", 
         RowBox[{"n", "-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"ConstantArray", "[", 
      RowBox[{"0", ",", "n"}], "]"}]}], "\[IndentingNewLine]", 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.678171532445856*^9, 3.678171598859295*^9}, {
  3.67817164106927*^9, 3.678171796222328*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"allDirectedGraphs", "[", "n_", "]"}], ":=", "\[IndentingNewLine]", 
  
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "graphs", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"graphs", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"AdjacencyGraph", "[", 
         RowBox[{
          RowBox[{"toMat", "[", 
           RowBox[{"#", ",", "n"}], "]"}], ",", 
          RowBox[{"DirectedEdges", "\[Rule]", "True"}]}], "]"}], "&"}], "/@", 
       
       RowBox[{"IntegerDigits", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Range", "[", 
           RowBox[{"2", "^", 
            RowBox[{"(", 
             RowBox[{"n", "*", 
              RowBox[{"(", 
               RowBox[{"n", "-", "1"}], ")"}]}], ")"}]}], "]"}], "-", "1"}], 
         ",", "2", ",", 
         RowBox[{"n", "*", 
          RowBox[{"(", 
           RowBox[{"n", "-", "1"}], ")"}]}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"DeleteDuplicatesBy", "[", 
      RowBox[{"graphs", ",", "CanonicalGraph"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.6751445951220512`*^9, 3.675144633474648*^9}, 
   3.675144838053624*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"allUndirectedGraphs", "[", "n_", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "graphs", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"graphs", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"AdjacencyGraph", "[", 
         RowBox[{"toMatU", "[", 
          RowBox[{"#", ",", "n"}], "]"}], "]"}], "&"}], "/@", 
       RowBox[{"IntegerDigits", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Range", "[", 
           RowBox[{"2", "^", 
            RowBox[{"(", 
             RowBox[{"n", "*", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"n", "-", "1"}], ")"}], "/", "2"}]}], ")"}]}], "]"}], 
          "-", "1"}], ",", "2", ",", 
         RowBox[{"n", "*", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"n", "-", "1"}], ")"}], "/", "2"}]}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"DeleteDuplicatesBy", "[", 
      RowBox[{"graphs", ",", "CanonicalGraph"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"m2", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Graph", "[", 
       RowBox[{"#", ",", 
        RowBox[{"VertexCoordinates", "\[Rule]", 
         RowBox[{"CirclePoints", "[", "2", "]"}]}]}], "]"}], "&"}], "/@", 
     RowBox[{"SortBy", "[", 
      RowBox[{
       RowBox[{"allDirectedGraphs", "[", "2", "]"}], ",", "EdgeCount"}], 
      "]"}]}]}], ";"}], "//", "AbsoluteTiming"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"m3", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Graph", "[", 
       RowBox[{"#", ",", 
        RowBox[{"VertexCoordinates", "\[Rule]", 
         RowBox[{"CirclePoints", "[", "3", "]"}]}]}], "]"}], "&"}], "/@", 
     RowBox[{"SortBy", "[", 
      RowBox[{
       RowBox[{"allDirectedGraphs", "[", "3", "]"}], ",", "IGIsoclass"}], 
      "]"}]}]}], ";"}], "//", "AbsoluteTiming"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"m4", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Graph", "[", 
       RowBox[{"#", ",", 
        RowBox[{"VertexCoordinates", "\[Rule]", 
         RowBox[{"CirclePoints", "[", "4", "]"}]}]}], "]"}], "&"}], "/@", 
     RowBox[{"SortBy", "[", 
      RowBox[{
       RowBox[{"allDirectedGraphs", "[", "4", "]"}], ",", "IGIsoclass"}], 
      "]"}]}]}], ";"}], "//", "AbsoluteTiming"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.001439`", ",", "Null"}], "}"}]], "Output"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.017336`", ",", "Null"}], "}"}]], "Output"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.014957`", ",", "Null"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"u2", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Graph", "[", 
       RowBox[{"#", ",", 
        RowBox[{"VertexCoordinates", "\[Rule]", 
         RowBox[{"CirclePoints", "[", "2", "]"}]}]}], "]"}], "&"}], "/@", 
     RowBox[{"SortBy", "[", 
      RowBox[{
       RowBox[{"allUndirectedGraphs", "[", "2", "]"}], ",", "EdgeCount"}], 
      "]"}]}]}], ";"}], "//", "AbsoluteTiming"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"u3", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Graph", "[", 
       RowBox[{"#", ",", 
        RowBox[{"VertexCoordinates", "\[Rule]", 
         RowBox[{"CirclePoints", "[", "3", "]"}]}]}], "]"}], "&"}], "/@", 
     RowBox[{"SortBy", "[", 
      RowBox[{
       RowBox[{"allUndirectedGraphs", "[", "3", "]"}], ",", "IGIsoclass"}], 
      "]"}]}]}], ";"}], "//", "AbsoluteTiming"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"u4", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Graph", "[", 
       RowBox[{"#", ",", 
        RowBox[{"VertexCoordinates", "\[Rule]", 
         RowBox[{"CirclePoints", "[", "4", "]"}]}]}], "]"}], "&"}], "/@", 
     RowBox[{"SortBy", "[", 
      RowBox[{
       RowBox[{"allUndirectedGraphs", "[", "4", "]"}], ",", "IGIsoclass"}], 
      "]"}]}]}], ";"}], "//", "AbsoluteTiming"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.001142`", ",", "Null"}], "}"}]], "Output"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.003578`", ",", "Null"}], "}"}]], "Output"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.019168`", ",", "Null"}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"MANlabels", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<003\>\"", ",", "\"\<012\>\"", ",", "\"\<021U\>\"", ",", 
     "\"\<102\>\"", ",", "\"\<021C\>\"", ",", "\"\<111D\>\"", ",", 
     "\"\<021D\>\"", ",", "\"\<030T\>\"", ",", "\"\<120D\>\"", ",", 
     "\"\<111U\>\"", ",", "\"\<201\>\"", ",", "\"\<030C\>\"", ",", 
     "\"\<120C\>\"", ",", "\"\<120U\>\"", ",", "\"\<210\>\"", ",", 
     "\"\<300\>\""}], "}"}]}], ";"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"zimport", "[", "filename_", "]"}], ":=", 
  RowBox[{"Uncompress", "@", 
   RowBox[{"Import", "[", 
    RowBox[{"filename", ",", "\"\<String\>\""}], "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"zexport", "[", 
   RowBox[{"filename_", ",", "data_"}], "]"}], ":=", 
  RowBox[{"Export", "[", 
   RowBox[{"filename", ",", 
    RowBox[{"Compress", "[", "data", "]"}], ",", "\"\<String\>\""}], 
   "]"}]}]}], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDirectory", "@", 
   RowBox[{"FileNameJoin", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<IGraphM\>\""}], 
     "}"}], "]"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"zexport", "[", "\[IndentingNewLine]", 
  RowBox[{"\"\<IGData.mz\>\"", ",", "\[IndentingNewLine]", 
   RowBox[{"<|", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<AllDirectedGraphs\>\"", ",", "2"}], "}"}], "\[Rule]", 
      "m2"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<AllDirectedGraphs\>\"", ",", "3"}], "}"}], "\[Rule]", 
      "m3"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<AllDirectedGraphs\>\"", ",", "4"}], "}"}], "\[Rule]", 
      "m4"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<AllUndirectedGraphs\>\"", ",", "2"}], "}"}], "\[Rule]", 
      "u2"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<AllUndirectedGraphs\>\"", ",", "3"}], "}"}], "\[Rule]", 
      "u3"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<AllUndirectedGraphs\>\"", ",", "4"}], "}"}], "\[Rule]", 
      "u4"}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<MANTriadLabels\>\"", "\[Rule]", 
      RowBox[{"AssociationThread", "[", 
       RowBox[{"MANlabels", ",", "m3"}], "]"}]}]}], "\[IndentingNewLine]", 
    "|>"}]}], "\[IndentingNewLine]", "]"}]], "Input"],

Cell[BoxData["\<\"IGData.mz\"\>"], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ResetDirectory", "[", "]"}], ";"}]], "Input"]
},
WindowSize->{950, 721},
WindowMargins->{{206, Automatic}, {Automatic, 34}},
PrivateNotebookOptions->{"FileOutlineCache"->False},
TrackCellChangeTimes->False,
FrontEndVersion->"11.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (July 13, \
2016)",
StyleDefinitions->"Default.nb"
]

