Notebook[{
Cell[BoxData[
 RowBox[{"Off", "[", 
  RowBox[{"General", "::", "stop"}], "]"}]], "Input",
 CellLabel->"In[1]:=",ExpressionUUID->"6869e0a7-b9b9-4850-9e52-0529b62a2912"],

Cell[BoxData[
 RowBox[{"<<", "IGraphM`"}]], "Input",
 CellLabel->"In[2]:=",ExpressionUUID->"8e1d63c3-7f89-456e-8de8-c2f2c258d8fd"],

Cell[BoxData[
 RowBox[{"layouts", "=", 
  RowBox[{"Symbol", "/@", 
   RowBox[{"Names", "[", "\"\<IGLayout*\>\"", "]"}]}]}]], "Input",
 CellLabel->"In[3]:=",ExpressionUUID->"da13cc9b-041a-48ff-a629-326d9db61f17"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "42", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "0", "]"}], "=", 
   RowBox[{"Graph", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "1", "]"}], "=", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<NetworkGraph\>\"", ",", "\"\<LesMiserables\>\""}], "}"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "2", "]"}], "=", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<NetworkGraph\>\"", ",", "\"\<DolphinSocialNetwork\>\""}], 
     "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "3", "]"}], "=", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<NetworkGraph\>\"", ",", "\"\<ZacharyKarateClub\>\""}], 
     "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"g", "[", "4", "]"}], "=", 
    RowBox[{"Graph", "[", 
     RowBox[{
      RowBox[{"Range", "[", "128", "]"}], ",", 
      RowBox[{"{", "}"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"ExampleData", "[", 
     RowBox[{"{", 
      RowBox[{
      "\"\<NetworkGraph\>\"", ",", "\"\<BipartiteDiseasomeNetwork\>\""}], 
      "}"}], "]"}], ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "5", "]"}], "=", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<NetworkGraph\>\"", ",", "\"\<PerlModuleAuthors\>\""}], 
     "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "6", "]"}], "=", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{
     "\"\<NetworkGraph\>\"", ",", "\"\<MetabolicNetworkYersiniaPestis\>\""}], 
     "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "7", "]"}], "=", 
   RowBox[{
   "GraphData", "[", "\"\<CremonaRichmondConfigurationGraph\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "8", "]"}], "=", 
   RowBox[{"RandomGraph", "[", 
    RowBox[{"PriceGraphDistribution", "[", 
     RowBox[{"48", ",", "2", ",", "1"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "9", "]"}], "=", 
   RowBox[{"RandomGraph", "[", 
    RowBox[{"BarabasiAlbertGraphDistribution", "[", 
     RowBox[{"100", ",", "1"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "10", "]"}], "=", 
   RowBox[{"RandomGraph", "[", 
    RowBox[{"WattsStrogatzGraphDistribution", "[", 
     RowBox[{"100", ",", "0.05"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "11", "]"}], "=", 
   RowBox[{"GraphData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<GeneralizedPrism\>\"", ",", " ", 
      RowBox[{"{", 
       RowBox[{"3", ",", " ", "5"}], "}"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "12", "]"}], "=", 
   RowBox[{"GridGraph", "[", 
    RowBox[{"{", 
     RowBox[{"10", ",", "15"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "13", "]"}], "=", 
   RowBox[{"GridGraph", "[", 
    RowBox[{"{", 
     RowBox[{"4", ",", "4", ",", "4", ",", "4"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "14", "]"}], "=", 
   RowBox[{"KaryTree", "[", "56", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "15", "]"}], "=", 
   RowBox[{"PetersenGraph", "[", 
    RowBox[{"17", ",", "15"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "16", "]"}], "=", 
   RowBox[{"GraphData", "[", "\"\<DodecahedralGraph\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "17", "]"}], "=", 
   RowBox[{"GraphData", "[", "\"\<IcosidodecahedralGraph\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "18", "]"}], "=", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<NetworkGraph\>\"", ",", "\"\<PowerGrid\>\""}], "}"}], 
    "]"}]}], ";"}]}], "Input",
 CellLabel->"In[4]:=",ExpressionUUID->"22510cb5-9ae0-4799-a4b4-645bec10fa4a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"n", "=", "18"}], ";"}]], "Input",
 CellLabel->"In[24]:=",ExpressionUUID->"a1dc8ba3-b034-4b63-b039-ef5ff99946e1"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"VertexCount", "[", 
    RowBox[{"g", "[", "i", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", "n"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[25]:=",ExpressionUUID->"41429fb8-878a-42d6-9309-72affe4fe907"],

Cell[BoxData[{
 RowBox[{"IGSeedRandom", "[", "42", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CellPrint", "@", 
   RowBox[{"Cell", "[", 
    RowBox[{"\"\<Results\>\"", ",", "\"\<Section\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"CellPrint", "[", 
     RowBox[{"Cell", "[", 
      RowBox[{
       RowBox[{"\"\<Graph \>\"", "<>", 
        RowBox[{"ToString", "[", "i", "]"}]}], ",", "\"\<Subsection\>\""}], 
      "]"}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Do", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ly", "===", "IGLayoutBipartite"}], "&&", 
          RowBox[{"Not", "@", 
           RowBox[{"IGBipartiteQ", "[", 
            RowBox[{"g", "[", "i", "]"}], "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<Graph not bipartite\>\"", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Continue", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ly", "===", "IGLayoutDrL3D"}], "&&", 
          RowBox[{"MemberQ", "[", 
           RowBox[{
            RowBox[{"Length", "/@", 
             RowBox[{"WeaklyConnectedComponents", "[", 
              RowBox[{"g", "[", "i", "]"}], "]"}]}], ",", "1"}], "]"}]}], ",",
          "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
          "Print", "[", "\"\<DrL 3D doesn't like isolated vertices\>\"", 
           "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Continue", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ly", "===", "IGLayoutDavidsonHarel"}], "&&", 
          RowBox[{
           RowBox[{"VertexCount", "[", 
            RowBox[{"g", "[", "i", "]"}], "]"}], ">", "500"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<DavidsonHarel is slow\>\"", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Continue", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ly", "===", "IGLayoutGEM"}], "&&", 
          RowBox[{
           RowBox[{"VertexCount", "[", 
            RowBox[{"g", "[", "i", "]"}], "]"}], ">", "500"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<GEM is slow\>\"", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Continue", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MemberQ", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "IGLayoutSphere", ",", "IGLayoutFruchtermanReingold3D", ",", 
              "IGLayoutKamadaKawai3D", ",", "IGLayoutDrL3D"}], "}"}], ",", 
            "ly"}], "]"}], "&&", 
          RowBox[{
           RowBox[{"VertexCount", "[", 
            RowBox[{"g", "[", "i", "]"}], "]"}], ">", "1200"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<avoid large 3D layouts\>\"", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Continue", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MemberQ", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"IGLayoutPlanar", ",", "IGLayoutTutte"}], "}"}], ",", 
            "ly"}], "]"}], "&&", 
          RowBox[{"Not", "@", 
           RowBox[{"PlanarGraphQ", "[", 
            RowBox[{"g", "[", "i", "]"}], "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<Graph not planar\>\"", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Continue", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ly", "===", "IGLayoutTutte"}], "&&", 
          RowBox[{"Not", "@", 
           RowBox[{"KVertexConnectedGraphQ", "[", 
            RowBox[{"g", ",", "3"}], "]"}]}]}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<Graph not 3-connected\>\"", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Continue", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"Labeled", "[", 
         RowBox[{
          RowBox[{"ly", "[", 
           RowBox[{"g", "[", "i", "]"}], "]"}], ",", "ly"}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"ly", ",", "layouts"}], "}"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", "n"}], "}"}]}], "\[IndentingNewLine]", 
  "]"}]}], "Input",ExpressionUUID->"5d843435-a778-4c1b-b60f-3c56630b56f5"]
},
WindowSize->{1067, 1266},
WindowMargins->{{20, Automatic}, {Automatic, 44}},
PrivateNotebookOptions->{"FileOutlineCache"->False},
TrackCellChangeTimes->False,
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (October 15, 2018)",
StyleDefinitions->"Default.nb"
]

